---
# tasks file for roles/netbox_inventory_item
- name: Extract the Power supply data
  set_fact:
    power_supplies: >-
      {%- set result = [] -%}
      {%- for device_name, device_value in parsed_data.items() -%}
        {%- if device_value['power_supply'] | length > 0 and device_value.get('is_stack') == True -%}
          {%- for item in device_value['power_supply']  -%}
            {%- set switch_number = item['switch'].split()[-1] -%}
            {%- set _ = result.append({
              "device_name": hostname ~ "-" ~ switch_number,
              "power_supply_id": item['power_supply_id'],
              "serial_number": item['serial_number'],
              "model": item['model'],
              "power_supply_name": hostname ~ "-" ~ switch_number ~ "_" ~ "psu" ~ "_" ~  item['power_supply_id']
            }) -%}
          {%- endfor -%}
        {%- elif device_value['power_supply'] | length > 0 and device_value.get('is_stack') == False -%}
          {%- for item in device_value['power_supply'] -%}
            {%- set _ = result.append({
              "device_name": hostname,
              "power_supply_id": item['power_supply_id'],
              "serial_number": item['serial_number'],
              "model": item['model'],
              "power_supply_name": hostname ~ "_" ~ "psu" ~ "_" ~  item['power_supply_id']
            }) -%}
          {%- endfor -%}
        {%- endif -%}
      {%- endfor -%}
      {{ result | unique }}

- debug:
    var: power_supplies | type_debug
          
- name: Create inventory item role within NetBox with only required information - Power Supply
  netbox.netbox.netbox_inventory_item_role:
    netbox_url: "{{ item_netbox_url }}"
    netbox_token: "{{ item_netbox_token }}"
    validate_certs: False
    state: present
    data:
      name: "POWER_SUPPLY"
      slug: "POWER_SUPPLY"
    state: present
  when: power_supplies | length > 0

- name: Create inventory item with parent - Power Supply
  netbox.netbox.netbox_inventory_item:
    netbox_url: "{{ item_netbox_url }}"
    netbox_token: "{{ item_netbox_token }}"
    validate_certs: False
    data:
      name: "{{ item.power_supply_name }}"
      device: "{{ item.device_name }}"
      serial: "{{ item.serial_number }}"
      part_id: "{{ item.model }}"
      manufacturer: "Cisco"
      inventory_item_role: "POWER_SUPPLY"
    state: present
  loop: "{{ power_supplies }}"
  when: power_supplies | length > 0
